' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form CombinedQResults 
   Caption         =   "Query Results"
   ClientHeight    =   4185
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5415
   LinkTopic       =   "Form2"
   ScaleHeight     =   4185
   ScaleWidth      =   5415
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox ResultTable 
      BackColor       =   &H80000011&
      Height          =   3975
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   5415
   End
End
Attribute VB_Name = "CombinedQResults"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Public Sub ProcessResults(res As DXResultsDL)

  Dim cnt As Integer
  cnt = 0
  
  ' First retrieve the documents/folders from the results collection
  Dim ddo As DXDDODL
  Dim cursor As DXSequentialIteratorDL
  Set cursor = res.createIterator
  Do While cursor.more
    Set ddo = cursor.Next
    ddo.retrieve
    cnt = cnt + 1
    'Display the data
    DisplayDDO ddo, cnt
  Loop                             ' end do while cursor.more
  
End Sub

Public Sub DisplayDDO(ddo As DXDDODL, cnt As Integer)

  Dim itemType As Integer, count As Integer, i As Integer
  Dim dataName As String
  Dim data As Variant
  Dim dataObj As Object
  itemType = ddo.getPropertyByName(DX_DL_PROPERTY_ITEM_TYPE)
  ResultTable.Text = ResultTable.Text & "=====> Item " & cnt & "<=====" & vbCrLf
  Select Case itemType
    Case DX_DL_DOCUMENT
      ResultTable.Text = ResultTable.Text & "Item is a document" & vbCrLf
      count = ddo.dataCount
      For i = 1 To count
        dataName = ddo.getDataName(i)
        If dataName = DX_DL_DKPARTS Then
          Set dataObj = ddo.GetData(i)
          ProcessParts dataObj
        Else
          data = ddo.GetData(i)
          If VarType(data) = vbString Or VarType(data) = vbInteger Or _
             VarType(data) = vbLong Then
            ResultTable.Text = ResultTable.Text & "attribute name: " & dataName & vbCrLf
            ResultTable.Text = ResultTable.Text & "value: " & data & vbCrLf
          End If
        End If
      Next                         ' end for i = 1 to count
    Case DX_DL_FOLDER
      ResultTable.Text = ResultTable.Text & "Item is a folder" & vbCrLf
      count = ddo.dataCount
      For i = 1 To count
        dataName = ddo.getDataName(i)
        If dataName = DX_DL_DKFOLDER Then
          Set dataObj = ddo.GetData(i)
          ProcessFolder dataObj
        Else
          data = ddo.GetData(i)
          If VarType(data) = vbString Or VarType(data) = vbInteger Or _
             VarType(data) = vbLong Then
            ResultTable.Text = ResultTable.Text & "attribute name: " & dataName & vbCrLf
            ResultTable.Text = ResultTable.Text & "value: " & data & vbCrLf
          End If
        End If
      Next                         ' end for i = 1 to count
    Case DX_DL_WORKBASKET
      ResultTable.Text = ResultTable.Text & "Item is a work basket" & vbCrLf
    Case DX_DL_WORKFOLW
      ResultTable.Text = ResultTable.Text & "Item is a work flow" & vbCrLf
  End Select
  
End Sub

Public Sub ProcessParts(parts As DXPartsDL)

  ResultTable.Text = ResultTable.Text & "This document has " & parts.cardinality & " parts" & vbCrLf
  Dim dataObjCursor As DXSequentialIteratorDL
  Set dataObjCursor = parts.createIterator
  Dim j As Integer
  j = 0
  Dim dkObj As Object
  
  Do While dataObjCursor.more
    j = j + 1
    ResultTable.Text = ResultTable.Text & "--------------------" & vbCrLf
    Set dkObj = dataObjCursor.Next
    If TypeOf dkObj Is DXBlobDL Then
      'Do something with the blob
      ResultTable.Text = ResultTable.Text & "Blob found - ItemID value " & dkObj.getItemId & " PartID value: " & dkObj.getPartId & " RepType value: " & dkObj.getRepType & " ContentClass : " & dkObj.getContentClass & vbCrLf
    Else
      ResultTable.Text = ResultTable.Text & "Unknown type of object!" & vbCrLf
    End If
  Loop                   ' end do while dataObjCursor.more
  
End Sub

Public Sub ProcessFolder(folder As DXFolderDL)

  Dim cnt As Integer
  cnt = 0

  ' First retrieve the documents/folders from the results collection
  Dim ddo As DXDDODL
  Dim cursor As DXSequentialIteratorDL
  Set cursor = folder.createIterator
  
  Do While cursor.more
    Set ddo = cursor.Next
    ddo.retrieve
    cnt = cnt + 1
    DisplayDDO ddo, cnt
  Loop                             ' end do while cursor.more
  
End Sub


Private Sub ResultTable_Change()

End Sub
