' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4245
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6615
   LinkTopic       =   "Form1"
   ScaleHeight     =   4245
   ScaleWidth      =   6615
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox QueryString 
      Height          =   1215
      Left            =   600
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   4
      Top             =   2160
      Width           =   4695
   End
   Begin VB.TextBox Status 
      Height          =   1215
      Left            =   480
      TabIndex        =   3
      Top             =   360
      Width           =   4815
   End
   Begin VB.CommandButton Execute 
      Caption         =   "Evaluate"
      Enabled         =   0   'False
      Height          =   495
      Left            =   3720
      TabIndex        =   2
      Top             =   3600
      Width           =   1695
   End
   Begin VB.CommandButton Disconnect 
      Caption         =   "Disconnect"
      Enabled         =   0   'False
      Height          =   615
      Left            =   1920
      TabIndex        =   1
      Top             =   3600
      Width           =   1335
   End
   Begin VB.CommandButton Connect 
      Caption         =   "Connect"
      Height          =   555
      Left            =   480
      TabIndex        =   0
      Top             =   3600
      Width           =   975
   End
   Begin VB.Label Label4 
      Caption         =   "Query"
      Height          =   255
      Left            =   1080
      TabIndex        =   6
      Top             =   1680
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "status"
      Height          =   255
      Left            =   960
      TabIndex        =   5
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private dsV4 As DXDatastoreV4

' Sample program for evaluate() and evaluateQuery()

' Connect to VI400 server

Private Sub Connect_Click()
  On Error GoTo HandleError
  Set dsV4 = New DXDatastoreV4
  dsV4.Connect "stealth3", "edms1", "edms1", ""
  Status.Text = "Connected to VI400 datastore " & dsV4.datastoreName
  Disconnect.Enabled = True
  Connect.Enabled = False
  Execute.Enabled = True

  Exit Sub
  
HandleError:
  Status.Text = str(Err.Number) & Err.Description

End Sub

' Disconnect from VI400 server

Private Sub Disconnect_Click()
  On Error GoTo HandleError
  dsV4.Disconnect
  Status.Text = "Disconnected from VI400"
  Connect.Enabled = True
  Disconnect.Enabled = False
  Execute.Enabled = False

  Exit Sub
  
HandleError:
  Status.Text = str(Err.Number) & Err.Description

End Sub

' show query results

Private Sub Execute_Click()
  On Error GoTo HandleError
  Dim myQuery As String
  Dim paramList(0) As DXNVPairV4
  Dim vParamList As Variant
  vParamList = paramList()
  Dim i As Long
  i = VarType(vParamList)

  ' Replace the following query string with your own -
  ' or get text from Query text box - remember to
  ' strip out the line feed and carriage control characters
  ' myQuery = QueryString.Text

  myQuery = "SEARCH=(INDEX_CLASS=V4SAMPLE,"
  myQuery = myQuery & "MAX_RESULTS=5,"
  myQuery = myQuery & "COND=(V4SEARCH_DocType <> NULL));"
  myQuery = myQuery & "OPTION=(CONTENT=YES;TYPE_QUERY=STATIC;TYPE_FILTER=FOLDERDOC)"
  QueryString.Text = myQuery

  Dim result As DXResultsV4

  ' use evaluate

  Dim res As New ProcessRes  ' create text box
  res.ShowString "results of DXDatastoreV4.evaluate(): "
  res.ShowString ""

  Set result = dsV4.evaluate(myQuery, DX_V4_PARAMETRIC_QL_TYPE)
  res.ProcessResults result
  res.Show

  ' use evaluateQuery
  
  Dim query As DXParametricQueryV4
  Dim res1 As New ProcessRes  ' create text box
  res1.ShowString "results of DXDatastoreV4.evaluateQuery(): "
  res1.ShowString ""

  Set query = New DXParametricQueryV4
  query.init dsV4, myQuery
  Set result = dsV4.evaluateQuery(query)
  res1.ProcessResults result
  res1.Show

  Exit Sub
  
HandleError:
  Status.Text = str(Err.Number) & Err.Description
  
End Sub

