/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

/*
 * Filename       : TExecuteGetMatches2TS.cpp
 * Description    : Connect to Text Search Datastore.
 *                  Create query string.
 *                  Get results in a resultset cursor.
 *                  Get match highlighting information.
 *                  Loop thru results.
 *                  Display items found.
 *                  Disconnect from Text Search Datastore.
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreTS.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <dkResultSetCursor.hpp>
#include <DKDDO.hpp>
#include <DKAny.hpp>
#include <DKPid.hpp>
#include <dkCollection.hpp>
#include <DKMatchesInfoTS.hpp>
#include <DKMatchesDocSectionTS.hpp>
#include <DKMatchesParagraphTS.hpp>
#include <DKMatchesTextItemTS.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
    cout << "begin..." << endl;
  
    // Indicate this is a Console Application on Windows NT/95 for error
    // message code page conversion to OEM code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_SS_WINDOWS is the default.
    DKEnvironment::setSubSystem(DK_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //--------------------------------------------------------------   
      if (argc < 4)
      {
       cout<<"Usage: "<<endl;
       cout<<"  TExecuteGetMatchesTS2 <srchSrv> <tmindex> <libSrvName>" << endl;
       return;
      }
      // ### get input parameters
    DKString srchSrv = DKString(argv[1]);
    DKString strIndex = DKString(argv[2]);
    DKString strLibName = DKString(argv[3]);

    DKDatastoreTS dsTS; // must be outside try/catch block

    try {
    dkResultSetCursor* pCur = 0;
    cout << "Datastore TS created" << endl;
    DKAny a;
    cout << "connecting to datastore" << endl;
    DKString strConnStr = "LIBACCESS=(";
    strConnStr += strLibName;
    strConnStr += ",FRNADMIN,PASSWORD)";
    dsTS.connect(srchSrv,"","",strConnStr);
    cout << "connected to datastore srchSrv: " << srchSrv << " libSrvName: " << strLibName << endl;
    DKString cmd = "SEARCH=";
    cmd += "(COND=(UNIX));";
    cmd += "OPTION=(SEARCH_INDEX=";
    cmd += strIndex;
    cmd += ";MAX_RESULTS=5)";
    cout << "query string " << cmd << endl;
    cout << "executing query" << endl;
    pCur = dsTS.execute(cmd); 
    cout << "query executed" << endl;
    DKDDO *p = 0;
    ushort j = 0;
    ushort cnt = 1;
    DKString strData;
    short sData = 0;
    long lData = 0;
    long lData2 = 0;
    dkDataObjectBase *pDOBase = 0;
    DKMatchesInfoTS *pMInfo = 0;
    DKMatchesDocSectionTS *pMSect = 0;
    DKMatchesParagraphTS *pMPara = 0;
    DKMatchesTextItemTS  *pMText = 0;
    long li = 0;
    long lj = 0;
    long lk = 0;
    long lm = 0;
    long numSects = 0;
    long numParas = 0;
    long numTextItems = 0;
    long numNewLines = 0;
    long numMatches = 0;
    long numMatchItems = 0;
    DKString strDataName;
    DKString strDID = "";
    DKString strXNAME = "";
    long inc = 0;
    DKPid pid;
    while (pCur->isValid()) 
    {
     p = pCur->fetchNext();
     if (p != 0)
     {
      cout << "record " << cnt << endl;
      pid = p->getPid();
      cout << " Pid String " << pid.pidString() << endl;
      for (j = 1; j <= p->dataCount(); j++)
      {
       a = p->getData(j);
       strDataName = p->getDataName(j);
       if (strDID == "")
       {
        strDID = pid.getId();
        cout << "Document Id is " << strDID << endl;
       }
       if (strXNAME == "")
       {
        strXNAME = p->getObjectType();
       }
       switch (a.typeCode())
       {
        case DKAny::tc_string :
        {
         strData = a;
         cout << "attribute name : " << strDataName << " type: string" << " value : " << strData << endl;
         break;
        }
        case DKAny::tc_long :
        {
         lData = a;
         cout << "attribute name : " << strDataName << " type: long" <<" value : " << lData << endl;
         break;
        }
        case DKAny::tc_short :
        {
         sData = a;
         cout << "attribute name : " << strDataName << " type: short" << " value : " << sData << endl;
         break;
        }
        case DKAny::tc_dobase :
        {
         pDOBase = a;
         break;
        }
       }
      } // for loop
      cout << " Get MatchesInfoTS " << endl;
      pMInfo = dsTS.getMatches(pCur,strDID,strXNAME,FALSE);
      strDID = "";
      strXNAME = "";
      if (pMInfo != 0)
      {
       cout << " ************* Doc matches info **************** " << endl;
       strDataName = pMInfo->getDocumentName();
       numSects = pMInfo->numberOfSections();
       cout << "document name : " << strDataName \
            << " number of sections : " << numSects << endl;
       for (li = 1; li <= numSects; li++)
       {
        pMSect = pMInfo->getSection(li);
        strDataName = pMSect->getSectionName();
        numParas = pMSect->numberOfParagraphs();
        cout << "section name : " << li << " " << strDataName \
             << " number of paragraphs : " << numParas << endl;
        for (lj = 1; lj <= numParas; lj++)
        {
         pMPara = pMSect->getParagraph(lj);
         lData = pMPara->getCCSID();
         lData2 = pMPara->getLanguageId();
         numTextItems = pMPara->numberOfTextItems();
         cout << "paragraph : ccsid " << lData << " lang " << lData2 << " " \
             << " number of text items : " << numTextItems << endl;
         for (lk = 1; lk <= numTextItems; lk++)
         {
          pMText = pMPara->getTextItem(lk);
          strDataName = pMText->getText();
          cout << "text item : " << lk << " " << strDataName << endl;
          if (pMText->isMatch() == TRUE)
          {
  	   numMatchItems = pMText->numberOfMatches();
	   cout << " number of matches found " << numMatchItems << endl;
  	   for (lm = 1; lm <= numMatchItems; lm++)
 	   {
	    pMText->setMatchIndex(lm);
 	    lData = pMText->getOffset();
 	    lData2 = pMText->getLength();
            cout << "text match found : offset " << lData << " len " << lData2 << endl;
	    numMatches++;
	   }
          }
          numNewLines = pMText->numberOfNewLines();
          cout << "number of text New lines :  " << numNewLines << endl;
         }
        }
       }
       cout << "number of matches found " << numMatches << endl;
       numMatches = 0;
       delete pMInfo;
      }       
      cnt++;
      delete p;
     }
    }
    cnt--;
    cout << "number of records " << cnt << endl;
    if (pCur != 0)
      delete pCur;
     dsTS.disconnect();
     cout << "datastore disconnected" << endl;
    }
    catch(DKException &exc)
    {
      cout << "Error id " << exc.errorId() << endl;
      cout << "Exception id " << exc.exceptionId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
       cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
       const DKExceptionLocation* p = exc.locationAtIndex(g);
       cout << "Filename: " << p->fileName() << endl;
       cout << "Function: " << p->functionName() << endl;
       cout << "LineNumber: " << p->lineNumber() << endl;
      } 
      cout << "Exception Class Name: " << exc.name() << endl;
    }

    cout << "done ..." << endl;
}

