REM ----------------------------------------------------------------------------------------
REM @copyright(disclaimer) 
REM Licensed Materials - Property of IBM
REM IBM Information Integrator for Content V8.2  (program number 5724-B43)
REM (c ) Copyright IBM Corp. 1998, 2002, 2003. All Rights Reserved.
REM 
REM US Government Users Restricted Rights
REM Use, duplication or disclosure restricted by GSA ADP Schedule
REM Contract with IBM Corp.
REM 
REM DISCLAIMER OF WARRANTIES :
REM 
REM Permission is granted to copy and modify this Sample code, and to
REM distribute modified versions provided that both the copyright
REM notice,- and this permission notice and warranty disclaimer appear in all copies and 
REM modified versions. 
REM 
REM THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
REM IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
REM IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
REM WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
REM IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
REM INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
REM SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
REM SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
REM SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
REM THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
REM OF THE POSSIBILITY OF SUCH DAMAGES.
REM
REM @endCopyright
REM ----------------------------------------------------------------------------------------
@echo OFF
echo . ================================================
echo . IBM Information Integrator for Content V8.2
echo . ------------------------------------------------
echo . Tool Script:  compileSamplesICM.bat (WIN)
echo . Description:  Compile All ICM C++ Samples
echo . ================================================
echo . 
echo . Compile All Samples
echo .      This tool compiles all C++ API Samples for
echo .      the ICM connector located in this directory.
echo .      All files in the 'bin' and 'obj' subfolders
echo .      will be deleted.
echo .
echo . Prepare Resource Files Needed
echo .      All resource files used will also be copied
echo .      to the 'bin' subdirectory.
echo .
echo . Output
echo .      The compiled samples and any resource files
echo .      they use will appear in the 'bin' subfolder.
echo .
echo . Prerequisits
echo .      The Information Integrator Development
echo .      Environment must be set.  For example, the
echo .      Development Window or the environment script,
echo .      cmbenv81, may be used.  The following
echo .      environment variables must be set correctly.
echo .      Using the 8-character Folder & File names
echo .      may eliminate difficulties.
echo .       - CMBROOT  :  Root Directory of Information
echo .                     Integrator for Content
echo .       - DB2HOME  :  DB2 SQLLIB Directory
echo .       - MSDEV    :  Microsoft Visual C++ Directory
echo .       - DKCPPVER :  Microsoft Visual C++ Version:
echo .                       Options: '6' or '7' (.Net)
echo .
echo . ================================================
echo .
echo . ------------------------------------------------
echo . Deleting 'bin' and 'obj' subfolder contents...
echo . ------------------------------------------------
del /F /Q /S .\bin\*.*
del /F /Q /S .\obj\*.*
echo .
echo . ------------------------------------------------
echo . Compiling Samples...
echo . ------------------------------------------------
@echo ON
nmake -f SAttributeDefinitionCreationICM.mak.nt
nmake -f SAttributeDefinitionDeletionICM.mak.nt
nmake -f SAttributeDefinitionRetrievalICM.mak.nt
nmake -f SAttributeDefinitionUpdateICM.mak.nt
nmake -f SAttributeGroupDefCreationICM.mak.nt
nmake -f SAttributeGroupDefDeletionICM.mak.nt
nmake -f SAttributeGroupDefRetrievalICM.mak.nt
nmake -f SAttributeGroupDefUpdateICM.mak.nt
nmake -f SConnectDisconnectICM.mak.nt
nmake -f SDocModelItemICM.mak.nt
nmake -f SDocRoutingDefinitionCreationICM.mak.nt
nmake -f SDocRoutingDefinitionDeletionICM.mak.nt
nmake -f SDocRoutingListingICM.mak.nt
nmake -f SDocRoutingProcessingICM.mak.nt
nmake -f SFolderICM.mak.nt
nmake -f SInsuranceModelItemCreationICM.mak.nt
nmake -f SInsuranceModelItemDeletionICM.mak.nt
nmake -f SInsuranceModelItemRetrievalICM.mak.nt
nmake -f SItemCreationICM.mak.nt
nmake -f SItemDeletionICM.mak.nt
nmake -f SItemRetrievalICM.mak.nt
nmake -f SItemTypeCreationICM.mak.nt
nmake -f SItemTypeDeletionICM.mak.nt
nmake -f SItemTypeRetrievalICM.mak.nt
nmake -f SItemTypeUpdateICM.mak.nt
nmake -f SItemUpdateICM.mak.nt
nmake -f SLinksICM.mak.nt
nmake -f SLinkTypeDefinitionCreationICM.mak.nt
nmake -f SLinkTypeDefinitionDeletionICM.mak.nt
nmake -f SLinkTypeDefinitionRetrievalICM.mak.nt
nmake -f SLinkTypeDefinitionUpdateICM.mak.nt
nmake -f SReferenceAttrDefCreationICM.mak.nt
nmake -f SReferenceAttrDefDeletionICM.mak.nt
nmake -f SReferenceAttrDefRetrievalICM.mak.nt
nmake -f SReferenceAttrDefUpdateICM.mak.nt
nmake -f SResourceItem3rdPartyIngestICM.mak.nt
nmake -f SResourceItem3rdPartyRetrieveICM.mak.nt
nmake -f SResourceItem3rdPartyUpdateICM.mak.nt
nmake -f SResourceItemCreationICM.mak.nt
nmake -f SResourceItemDeletionICM.mak.nt
nmake -f SResourceItemRetrievalICM.mak.nt
nmake -f SResourceItemUpdateICM.mak.nt
nmake -f SResourceMgrDefCreationICM.mak.nt
nmake -f SResourceMgrDefDeletionICM.mak.nt
nmake -f SResourceMgrDefRetrievalICM.mak.nt
nmake -f SResourceMgrDefSetDefaultICM.mak.nt
nmake -f SSampleModelBuildICM.mak.nt
nmake -f SSampleModelDeleteICM.mak.nt
nmake -f SSampleModelItemDeletionICM.mak.nt
nmake -f SSearchICM.mak.nt
nmake -f SSemanticTypeCreationICM.mak.nt
nmake -f SSemanticTypeDeletionICM.mak.nt
nmake -f SSemanticTypeRetrievalICM.mak.nt
nmake -f SSemanticTypeUpdateICM.mak.nt
nmake -f SSMSCollectionDefCreationICM.mak.nt
nmake -f SSMSCollectionDefDeletionICM.mak.nt
nmake -f SSMSCollectionDefRetrievalICM.mak.nt
nmake -f SSMSCollectionDefSetDefaultICM.mak.nt
nmake -f STextIndexUpdateICM.mak.nt
nmake -f STransactionsICM.mak.nt
nmake -f SVideoItemCreateICM.mak.nt
nmake -f SVideoItemDeletionICM.mak.nt
nmake -f SVideoItemPlayICM.mak.nt
nmake -f SVideoItemRetrievalICM.mak.nt
nmake -f SVideoItemTypeCreateICM.mak.nt
nmake -f SVideoItemTypeDeleteICM.mak.nt
nmake -f SVideoItemUpdateICM.mak.nt
@echo OFF
echo .
echo . ------------------------------------------------
echo . Copying Resource Files to 'bin' subfolder...
echo . ------------------------------------------------
copy SInsuranceModelICM_AccidenReport_0120200130.tif .\bin\.
copy SInsuranceModelICM_AccidenReport_0506200110.tif .\bin\.
copy SInsuranceModelICM_AccidenReport_729200173.tif .\bin\.
copy SInsuranceModelICM_AccidenReport_CABlank.pdf .\bin\.
copy SInsuranceModelICM_AccidenReport_NYBlank.pdf .\bin\.
copy SInsuranceModelICM_Adjustment_4-852369.tif .\bin\.
copy SInsuranceModelICM_Adjustment_5-654123.tif .\bin\.
copy SInsuranceModelICM_Adjustment_6-987654.tif .\bin\.
copy SInsuranceModelICM_Adjustment_Blank.pdf .\bin\.
copy SInsuranceModelICM_Claim_4-852369.tif .\bin\.
copy SInsuranceModelICM_Claim_5-654123.tif .\bin\.
copy SInsuranceModelICM_Claim_6-987654.tif .\bin\.
copy SInsuranceModelICM_Claim_Blank.pdf .\bin\.
copy SInsuranceModelICM_Photo_1ABC089.jpg .\bin\.
copy SInsuranceModelICM_Photo_4IBM134-1.tif .\bin\.
copy SInsuranceModelICM_Photo_4IBM134-2.tif .\bin\.
copy SInsuranceModelICM_Photo_6usa676-1.tif .\bin\.
copy SInsuranceModelICM_Photo_6usa676-2.tif .\bin\.
copy SInsuranceModelICM_Policy_10285265410.tif .\bin\.
copy SInsuranceModelICM_Policy_10315975308.tif .\bin\.
copy SInsuranceModelICM_Policy_10452136412.tif .\bin\.
copy SInsuranceModelICM_Policy_Blank.pdf .\bin\.
copy SResourceItemICM_Document1.doc .\bin\.
copy SResourceItemICM_Document2.doc .\bin\.
copy SResourceItemICM_Picture1.bmp .\bin\.
copy SResourceItemICM_Picture2.bmp .\bin\.
copy SResourceItemICM_Text1.txt .\bin\.
copy SResourceItemICM_Text2.txt .\bin\.
copy SVideoItemICM_Video1.mpg .\bin\.
copy SVideoItemICM_Video2.mpg .\bin\.
echo .
echo . ================================================
echo . Script Completed.
echo . ------------------------------------------------
echo . NOTE:  Do not forget to review 'Getting Started'
echo .        and the complete functionality to sample
echo .        mapping in the 'Reference Index' sections
echo .        of the README_SAMPLES_C++_ICM.txt file.
echo . ================================================
echo .
