/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

//*****************************************************************************
// Class Name  = Class ItemRequestEvent
// Description = Event for requesting a CM search.
// Author      = afic
// Create Date = 02/26/1999
//
// Change History
//   defect  #  nn/nn/1999 abc  fix aaa bug
//   feature #  nn/nn/1999 xyz  add xxx feature
//
//*****************************************************************************

import com.ibm.mm.beans.CMBEventBase;

//*****************************************************************************
// Class/interface definition
//*****************************************************************************
/**
 * Event for requesting a CM search.
 *
 * @version   CMB 1.0
 * @see       com.ibm.mm.beans.ItemRequestListener
 */
public class ItemRequestEvent extends CMBEventBase {
    //*****************************************************************************
    // Public fields
    //*****************************************************************************
    /**
     * Event type IDs.
     */
    public final static int ITEM_RETRIEVE = 1;
    public final static int ITEM_COPYCREATE = 2;
    public final static int ATTR_VIEW = 3;
    public final static int ATTR_UPDATE = 4;
    public final static int ATTR_REINDEX = 5;
    public final static int ATTR_UNINDEX = 6;

    //*****************************************************************************
    // Constructors
    //*****************************************************************************
    /**
     * Construct a ItemRequestEvent.
     * @param source    the event source
     * @param id        the event type id
     */
    public ItemRequestEvent(Object source, int id) {
        super(source, id);
    }

    // * @param requestId  type Object, argument data, the search request ID for
    // *                   future cancelling the specified request
    /*
     * Construct a ItemRequestEvent, argument data provided.
     * @param source     the event source
     * @param id         the event type id
     * @param data       CMBItem data object
     */
    public ItemRequestEvent(Object source, int id, Object data) {
        super(source, id, data);
    }

    //*****************************************************************************
    // Copyright
    //*****************************************************************************
    private static final String ibmid = "5648-D03 and 5648-D04  " + "(C) Copyright IBM Corp. 1994,1999";
}