/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample of xdo BLOB for DataJoiner

/*
 * Filename       : TxdoCRUDFDJ.java
 * Description    : test add, update, delete, retrieve of BLOB for DJ - thru file.
 *                  (use the DB2 SAMPLE database, table EMP_PHOTO) 
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.internal.*;
import java.io.*;
import java.lang.*;
import java.util.*;

// TxdoCRUDFDJ class
public class TxdoCRUDFDJ implements DKConstantDJ
{


  // Main method
  public static void main(String argv[])
  {
          
      //*** for input parameters
      String database = new String(""),   // database
             userid = new String(""),     //userid 
  	     pw = new String(""); // pw

      // Indicate this is a Console Application on Windows NT/95 for error
      // message display in dos console code page. If this was a Windows
      // GUI (Graphic User Interface) Application this would not be necessary
      // because DK_CM_SS_WINDOWS is the default.
      DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);
      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
     
      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("  java TxdoCRUDFDJ " +
        "<database> <userid> <pw>" );
       return;
      }
      else
      {
       database = argv[0];
       userid = argv[1];
       pw = argv[2];
      } 

      //### setup table, colume, predicate, picture files
      String fileName1 =  "e:\\cmbroot\\samples\\java\\dl\\images\\tease.gif"; //for add
      String fileName2 =  "e:\\cmbroot\\samples\\java\\dl\\images\\web.gif";   //for update web.gif
      String table = "EMP_PHOTO";                           //from SAMPLE database of DJ
      String column = "PICTURE";                            //blob column 
      String predicate0 = "EMPNO = '000130' and PHOTO_FORMAT = 'gif'" ; //primary key of exist blob
      String predicate1 = "EMPNO = '000210' and PHOTO_FORMAT = 'gif'" ; //primary key for null blob

      DKDatastoreDJ dsDJ = null;
      try {
      // Constructing using default constuctor with init method
      dsDJ = new DKDatastoreDJ();
      System.out.println("connecting to datastore"); 
      dsDJ.connect(database,userid,pw,"");
      System.out.println("datastore connected " + database + " userid - " + userid);

      //### setup XDO
      DKBlobDJ axdo = new DKBlobDJ(dsDJ);
      DKPidXDODJ  apid = new DKPidXDODJ();
      apid.setTable(table);
      apid.setColumn(column);
      apid.setDataPredicate(predicate0);   //exist blob
      axdo.setPidObject(apid);
      System.out.println("table= " + axdo.getTable());
      System.out.println("column=" + ((DKPidXDODJ)(axdo.getPidObject())).getColumn());
      System.out.println("dataPredicate=" + ((DKPidXDODJ)(axdo.getPidObject())).getDataPredicate());

      //### retrieve the exist blob - 000130 gif
      System.out.println("length=" + axdo.length());   //in memory
      System.out.println("getSize=" + axdo.getSize()); //in datastore
      System.out.println("about to do retrieve(fileName)...");
      axdo.retrieve("F000130.gif");
      System.out.println("retrieve successfully...");    
      System.out.println("about to do open()");
      axdo.setInstanceOpenHandler("lviewpro", true);   //use lviewpro in NT
      axdo.open();     //iexplore requires the file extension  

      //### add from memory to the null blob - 000210 gif
      apid.setDataPredicate(predicate1);  //null blob
      axdo.setPidObject(apid);
      System.out.println("table= " + axdo.getTable());
      System.out.println("column=" + axdo.getColumn());
      System.out.println("dataPredicate=" + axdo.getDataPredicate());
      System.out.println("before add length(in memory)= " + axdo.length());  //in memory
      System.out.println("before add size(in datastore)= " + axdo.getSize()); //size from datastore
      System.out.println("about to do add(fileName1)....");
      axdo.add(fileName1);       
      System.out.println("add successfully.... ");
      System.out.println("after add size(in datastore)= " + axdo.getSize());

      //### retrieve to memeory and open - 000210 gif
      System.out.println("about to do retrieve() of added blob...");
      axdo.retrieve();
      System.out.println("retrieve successfully...");
      System.out.println("about to do open()");
      axdo.setInstanceOpenHandler("lviewpro ", true);   //use lviewpro in NT
      axdo.open("000210.gif");     //iexplore requires the file extension 

      //### update the added blob - 00210 gif
      //== before update, the content length is the same
      System.out.println("before update, content length = " + axdo.length());
      System.out.println("about to do update(fileName2)...");
      axdo.update(fileName2);  
      System.out.println("After update, do retrieve and open() to verify it is updated.");
      axdo.retrieve();
      System.out.println("after update & retrieve, content length = " + axdo.length());
      axdo.open("000210.gif");     //iexplore requires the file extension 

      //### delete the added blob - 000210 gif 
      System.out.println("Delete the above added blob ...");
      axdo.del();
      System.out.println("delete successfully!");

      dsDJ.commit();
      dsDJ.disconnect();
      System.out.println("datastore disconnected");
      dsDJ.destroy(); 
    }
    catch (DKException exc)
    {
     try {
     dsDJ.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
     dsDJ.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

