/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TCreateDelEntQBIC class
public class TCreateDelEntQBIC implements DKConstantDL {

  // Main method
  public static void main(String argv[]){

     // Indicate this is a Console Application on Windows NT/95 for error
     // message display in dos console code page. If this was a Windows
     // GUI (Graphic User Interface) Application this would not be necessary
     // because DK_CM_SS_WINDOWS is the default.
     DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

     //-------------------------------------------------------------- 
     // Checking for input parameters
     //-------------------------------------------------------------- 
   
     if (argv.length < 5) {
         System.out.println("Usage: " );
         System.out.println("  java TCreateDelEntQBIC  <qbicSrv> <userid> <pw> <qbicdb> <qbiccat> " );
         return;
     }
   
     String qbicSrv = argv[0];
     String userid  = argv[1];
     String pw      = argv[2];
     String qbicdb  = argv[3];
     String qbiccat = argv[4];
   
     DKDatastoreQBIC dsQBIC = null;
     try {
        dsQBIC = new DKDatastoreQBIC();
        DKDatastoreDefQBIC dsDef = null;
        DKDatabaseDefQBIC db = null;
        DKCatalogDefQBIC cat = null;
        DKFeatureDefQBIC feat = null;
	    System.out.println("Datastore QBIC created");
	    System.out.println("connecting to datastore");
	    dsQBIC.connect(qbicSrv,userid,pw,"");
	    System.out.println("datastore connected");
    
	    if (dsQBIC.isConnected())
	         System.out.println("connection is true ");
	    else
	         System.out.println("connection is false ");
       
        System.out.println("db name " + qbicdb + " cat name " + qbiccat);
        dsDef = (DKDatastoreDefQBIC)dsQBIC.datastoreDef();
	    System.out.println("Create database ");
        db = new DKDatabaseDefQBIC(dsQBIC);
        db.setName(qbicdb);
	    System.out.println("add database " + qbicdb);
	    dsDef.add(db);
	    System.out.println("Create catalog ");
        cat = new DKCatalogDefQBIC(dsQBIC);
        cat.setName(qbiccat);
	    System.out.println("add catalog " + qbiccat + " to database " + qbicdb);
        db.add(cat);
	    System.out.println("Create feature ");
        feat = new DKFeatureDefQBIC(dsQBIC);
        feat.setName(DK_QBIC_FEATURE_QBCOLORFEATURE);
	    System.out.println("add feature QbColorFeatureClass to catalog " + qbiccat + " - database " + qbicdb);
        cat.add(feat);
        System.out.println("get the db " + qbicdb);
        db = (DKDatabaseDefQBIC)dsDef.getEntity(qbicdb);
        System.out.println("get the cat " + qbiccat);
        cat = (DKCatalogDefQBIC)db.getSubEntity(qbiccat);
        System.out.println("get the feature QbColorFeatureClass");
        feat = (DKFeatureDefQBIC)cat.getAttr(DK_QBIC_FEATURE_QBCOLORFEATURE);
        System.out.println("delete the feature QbColorFeatureClass");
        feat.del();        
        System.out.println("delete the catalog");
        cat.del();        
        System.out.println("delete the database");
        db.del();        

        dsQBIC.disconnect();
        System.out.println("datastore disconnected");
        dsQBIC.destroy();
     }
     catch(Exception exc){
     	try {
     	    dsQBIC.destroy();
     	}
     	catch (Exception e)
     	{
     	 e.printStackTrace();
     	}        
        System.out.println("Exception message " + exc.getMessage());
        exc.printStackTrace();
     }
  }
}

